## tweeny 2+git20171120.b94ce07

=== CMakeLists.txt ===
# This file is part of the Tweeny library.
#
# Copyright (c) 2016 Leonardo G. Lucena de Freitas
# Copyright (c) 2016 Guilherme R. Costa
#
# Permission is hereby granted, free of charge, to any person obtaining a copy of
# this software and associated documentation files (the "Software"), to deal in
# the Software without restriction, including without limitation the rights to
# use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
# the Software, and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.

# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
# COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
# IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

# This file specifies an INTERFACE library, allowing you to include Tweeny in your CMake project.
# To use Tweeny in your project, put this folder under your source dir and use `add_subdirectory(tweeny)`. For every
# target that uses tweeny, a simple `target_link_libraries(target tweeny)` is sufficient to set up include and link
# instructions.

cmake_minimum_required(VERSION 3.0)
project(Tweeny)

# Setup variables and options
option(TWEENY_BUILD_EXAMPLES "Build examples contained in examples/ folder. It might require additional dependencies." ON)
option(TWEENY_BUILD_DOCUMENTATION "Attempts to build the documentation. You'll need doxygen and graphviz installed" ON)

# Setup version
include(cmake/SetupVersion.cmake)

# The library target
add_library(tweeny INTERFACE)

# Specify the C++ features a compiler should have to use this library.
if(NOT CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
    target_compile_features(tweeny
        INTERFACE
        cxx_auto_type
        cxx_variadic_templates
        cxx_lambdas
        cxx_nullptr
        cxx_right_angle_brackets
        cxx_static_assert
        cxx_template_template_parameters
    )
else()
    list(APPEND CMAKE_CXX_FLAGS -std=c++11)
endif()

# Set up include directories
target_include_directories(tweeny INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include/tweeny>
)

# Set up install
install(TARGETS tweeny EXPORT TweenyTargets)
install(DIRECTORY include/ DESTINATION include/tweeny)

# Set up export and config
include(cmake/SetupExports.cmake)

# Set up cpack
include(cmake/SetupCPack.cmake)

# Include examples
if (TWEENY_BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

if (TWEENY_BUILD_DOCUMENTATION)
    add_subdirectory(doc)
endif()

# This library is a convenience library to force files appear in the IDE properly.
add_library(tweeny-dummy
        include/tweeny.h
        include/tweeny.tcc
        include/tween.h
        include/tween.tcc
        include/tweenone.tcc
        include/tweenpoint.h
        include/tweenpoint.tcc
        include/tweentraits.h
        include/easing.h
        include/easingresolve.h
        include/int2type.h
        include/dispatcher.h)
set_target_properties(tweeny-dummy PROPERTIES LINKER_LANGUAGE CXX EXCLUDE_FROM_ALL TRUE)

#target_compile_options(tweeny INTERFACE -Weverything -Wno-c++98-compat -Wno-padded)

=== doc/CMakeLists.txt ===
# This file is part of the Tweeny library.
#
# Copyright (c) 2016 Leonardo G. Lucena de Freitas
# Copyright (c) 2016 Guilherme R. Costa
#
# Permission is hereby granted, free of charge, to any person obtaining a copy of
# this software and associated documentation files (the "Software"), to deal in
# the Software without restriction, including without limitation the rights to
# use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
# the Software, and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.

# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
# COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
# IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

# This cmake file creates and builds doxygen documentation. It also sets it in the install list.

find_package(Doxygen)
option(TWEENY_GENERATE_DOC "Generate HTML documentation" OFF)
option(TWEENY_INSTALL_EXAMPLES "Install examples with the doc" OFF)
if (TWEENY_GENERATE_DOC)
    set(DOC_ADD_TO_ALL ALL)
else()
    set(DOC_ADD_TO_ALL "")
endif()

if(DOXYGEN_FOUND)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
    file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/../README.md DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
    file(COPY
            ${CMAKE_CURRENT_SOURCE_DIR}/customdoxygen.css
            ${CMAKE_CURRENT_SOURCE_DIR}/doxy-boot.js
            ${CMAKE_CURRENT_SOURCE_DIR}/footer.html
            ${CMAKE_CURRENT_SOURCE_DIR}/header.html
            ${CMAKE_CURRENT_SOURCE_DIR}/DoxygenLayout.xml
            ${CMAKE_CURRENT_SOURCE_DIR}/MANUAL.dox
         DESTINATION
            ${CMAKE_CURRENT_BINARY_DIR}
    )
    add_custom_target(doc ${DOC_ADD_TO_ALL}
            ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
            COMMENT "Generating API documentation with Doxygen" VERBATIM)

    if (TWEENY_GENERATE_DOC)
        install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html DESTINATION share/doc/Tweeny)
    endif()

    if (TWEENY_INSTALL_EXAMPLES)
        install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../examples/sprite DESTINATION share/doc/Tweeny/examples)
        install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../examples/loop DESTINATION share/doc/Tweeny/examples)
        install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../examples/easings DESTINATION share/doc/Tweeny/examples)
    endif()

endif(DOXYGEN_FOUND)

=== examples/CMakeLists.txt ===
# This file is part of the Tweeny library.
#
# Copyright (c) 2016 Leonardo G. Lucena de Freitas
# Copyright (c) 2016 Guilherme R. Costa
#
# Permission is hereby granted, free of charge, to any person obtaining a copy of
# this software and associated documentation files (the "Software"), to deal in
# the Software without restriction, including without limitation the rights to
# use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
# the Software, and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.

# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
# COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
# IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

# The purpose of this file is to include all examples subdirectories.

find_package(SDL2 QUIET)

macro(add_example)
    set(TARGET ${ARGV0})
    set(SOURCES "${ARGN}")
    list(REMOVE_AT SOURCES 0)
    string(TOUPPER ${TARGET} TARGET_UPPER)
    option(TWEENY_EXAMPLE_${TARGET_UPPER} "Build the ${TARGET} example." ON)
    if (TWEENY_EXAMPLE_${TARGET_UPPER})
        add_executable(${TARGET} ${SOURCES})
        target_link_libraries(${TARGET} PRIVATE tweeny)
    endif()
endmacro()

if (CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -s ALLOW_MEMORY_GROWTH=1")
    set(CMAKE_EXECUTABLE_SUFFIX ".html")
endif()

add_example(multitype multitype/multitype.cpp)
add_example(easings easings/easings.cpp)
add_example(loop loop/loop.cpp)


if (SDL2_FOUND)
    add_example(sprite
        sprite/main.cpp
        sprite/stb_image.h
        sprite/sprite.cpp
        sprite/sprite.h
        sprite/engine.cpp
        sprite/engine.h
        sprite/input.cpp
        sprite/input.h
        sprite/resources.c
    )
    if (TWEENY_EXAMPLE_SPRITE)
        string(STRIP ${SDL2_LIBRARIES} SDL2_LIBS)
        target_link_libraries(sprite PRIVATE ${SDL2_LIBS})
        target_include_directories(sprite PRIVATE ${SDL2_INCLUDE_DIRS})
    endif()
else()
    message(STATUS "SDL2 was not found. sprite example will NOT be built")
endif()

=== debian/changelog ===
tweeny (2+git20171120.b94ce07-1) unstable; urgency=medium

  * Initial release (Closes: #894864)

 -- Hubert Chathi <uhoreg@debian.org>  Wed, 04 Apr 2018 17:06:02 -0400

=== debian/control ===
Source: tweeny
Section: libdevel
Priority: optional
Maintainer: Hubert Chathi <uhoreg@debian.org>
Build-Depends: debhelper (>=9), doxygen, graphviz, cmake
Standards-Version: 3.9.8
Homepage: https://github.com/mobius3/tweeny
Vcs-Git: https://salsa.debian.org/uhoreg/tweeny.git
Vcs-Browser: https://salsa.debian.org/uhoreg/tweeny

Package: libtweeny-dev
Architecture: all
Depends: ${misc:Depends}
Suggests: fonts-roboto-fontface, libjs-jquery, libjs-bootstrap
Description: modern C++ tweening library
 Tweeny is an inbetweening library designed for the creation of complex
 animations for games and other beautiful interactive software. It leverages
 features of modern C++ to empower developers with an intuitive API for
 declaring tweenings of any type of value, as long as they support arithmetic
 operations.
 .
 The goal of Tweeny is to provide means to create fluid interpolations when
 animating position, scale, rotation, frames or other values of screen objects,
 by setting their values as the tween starting point and then, after each tween
 step, plugging back the result.
 .
 It features:
 .
  * A descriptive and (hopefully) intuitive API,
  * 30+ easing functions,
  * Allows custom easing functions,
  * Multi-point tweening,
  * Simultaneous tween of heterogeneous value sets,
  * Timeline-like usage (allows seeking to any point),
  * Header-only
  * Zero external dependencies
  * Steps forwards or backwards :)
  * Accepts lambdas, functors and functions as step and seek callbacks

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ 

override_dh_auto_build:
	cd build && make doc

override_dh_auto_configure:
	mkdir build && cd build && cmake ..

## tweeny 3

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,7 +30,8 @@
 
 # Setup variables and options
 option(TWEENY_BUILD_EXAMPLES "Build examples contained in examples/ folder. It might require additional dependencies." ON)
-option(TWEENY_BUILD_DOCUMENTATION "Attempts to build the documentation. You'll need doxygen and graphviz installed" ON)
+option(TWEENY_BUILD_DOCUMENTATION "Attempts to build the documentation. You'll need doxygen and graphviz installed" OFF)
+option(TWEENY_BUILD_EXTRAS "Attempts to build extra goodies on extras/ folder. It will require additional dependencies" ON)
 
 # Setup version
 include(cmake/SetupVersion.cmake)
@@ -70,11 +71,6 @@
 # Set up cpack
 include(cmake/SetupCPack.cmake)
 
-# Include examples
-if (TWEENY_BUILD_EXAMPLES)
-    add_subdirectory(examples)
-endif()
-
 if (TWEENY_BUILD_DOCUMENTATION)
     add_subdirectory(doc)
 endif()
@@ -94,5 +90,3 @@
         include/int2type.h
         include/dispatcher.h)
 set_target_properties(tweeny-dummy PROPERTIES LINKER_LANGUAGE CXX EXCLUDE_FROM_ALL TRUE)
-
-#target_compile_options(tweeny INTERFACE -Weverything -Wno-c++98-compat -Wno-padded)

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -23,9 +23,7 @@
 # This cmake file creates and builds doxygen documentation. It also sets it in the install list.
 
 find_package(Doxygen)
-option(TWEENY_GENERATE_DOC "Generate HTML documentation" OFF)
-option(TWEENY_INSTALL_EXAMPLES "Install examples with the doc" OFF)
-if (TWEENY_GENERATE_DOC)
+if (TWEENY_BUILD_DOCUMENTATION)
     set(DOC_ADD_TO_ALL ALL)
 else()
     set(DOC_ADD_TO_ALL "")
@@ -35,10 +33,6 @@
     configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
     file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/../README.md DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
     file(COPY
-            ${CMAKE_CURRENT_SOURCE_DIR}/customdoxygen.css
-            ${CMAKE_CURRENT_SOURCE_DIR}/doxy-boot.js
-            ${CMAKE_CURRENT_SOURCE_DIR}/footer.html
-            ${CMAKE_CURRENT_SOURCE_DIR}/header.html
             ${CMAKE_CURRENT_SOURCE_DIR}/DoxygenLayout.xml
             ${CMAKE_CURRENT_SOURCE_DIR}/MANUAL.dox
          DESTINATION
@@ -49,14 +43,8 @@
             WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
             COMMENT "Generating API documentation with Doxygen" VERBATIM)
 
-    if (TWEENY_GENERATE_DOC)
+    if (TWEENY_BUILD_DOCUMENTATION)
         install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html DESTINATION share/doc/Tweeny)
     endif()
 
-    if (TWEENY_INSTALL_EXAMPLES)
-        install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../examples/sprite DESTINATION share/doc/Tweeny/examples)
-        install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../examples/loop DESTINATION share/doc/Tweeny/examples)
-        install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../examples/easings DESTINATION share/doc/Tweeny/examples)
-    endif()
-
 endif(DOXYGEN_FOUND)

=== debian/changelog ===
tweeny (3-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream fix for FTBFS with CMake 4. (Closes: #1113591)

 -- Adrian Bunk <bunk@debian.org>  Fri, 24 Oct 2025 16:26:57 +0300

tweeny (3-2) unstable; urgency=medium

  * Mark libtweeny-dev Multi-Arch: foreign. (Closes: #945942) Thanks to
    Helmut Grohne.

 -- Hubert Chathi <uhoreg@debian.org>  Tue, 24 Dec 2019 14:47:53 -0500

tweeny (3-1) unstable; urgency=medium

  * New upstream release.
    * Makes builds reproducible. (Closes: #897902)
    * Removed obsolete patches and links.
    * Examples have been removed from upstream.

 -- Hubert Chathi <uhoreg@debian.org>  Thu, 10 Jan 2019 09:28:44 -0500

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ 

override_dh_auto_build:
	cd build && make

override_dh_auto_configure:
	mkdir build && cd build && cmake .. -DTWEENY_BUILD_DOCUMENTATION=ON

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
   https://github.com/mobius3/tweeny/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
